#!/bin/sh
#
#
# This routine is used as part of the inflex installation procedure
#
# Make users creates user/group required by inflex
#

	
#
# Set our ANSI codes
don="\033[0;33m"
doff="\033[0;22m"
dg="\033[0;32m"
dw="\033[0;37m"
dr="\033[0;31m"

report=install.log
username=inflex
groupname=inflex
passwd=/etc/passwd
shadow=/etc/shadow
group=/etc/group
sendmailpg=`which sendmail`
adminemail=postmaster
libdir=/usr/lib
install_version="1.0.4 - Thu Mar 01 02:21:38 EST 2001 pldaniels <pldaniels@pldaniels.com>"

#
# Find SED
#
if [ -e /usr/bin/sed ]
then
	sedpg=/usr/bin/sed
	fi
	
if [ -e /bin/sed ]
then
	sedpg=/bin/sed
	fi
	
if [ -e /usr/local/bin/sed ]
then
	sedpg=/usr/local/bin/sed
	fi
	


function askow(){

	if [ -e ${inflexdir}/${source} ]
	then
		echo -en "'${source}' already exists, do you want to overwrite? (y/N) : "
		read x
		if [ "a$x" == "ay" ]
		then
			install -c -m $fmode -o ${username} -g ${groupname} ${source} ${inflexdir} >>$report 2>>$report
			fi
	else
		install -c -m $fmode -o ${username} -g ${groupname} ${source} ${inflexdir} >>$report 2>>$report
		fi

}		

	
			
function SR(){
	epath=`./escpath $replacewith`
	sedstring=s/$searchfor/$epath/
	${sedpg} ${sedstring} inflex.raw > inflex.raw_
	mv inflex.raw_ inflex.raw
	}


# Copy our .raw file to a safe place, for when we're finished up
#
cp inflex.raw inflex.raw.safe

echo "----------------------------------------------------------"
echo "-"
echo "- Inflex v1.0.0 PR3 Installation."
echo "-"
echo "-"
#
# First off, compile fixcf
echo "Compiling FixCF..."
make fixcf
echo -e ${don}done${doff}

# Then make and install ripMIME
echo "Compiling and installing ripMIME 1.0.0PR4..."
cd ripmime-1.0.0pr4
make
make install
cd ..
echo -e ${don}done${doff}



searchfor=__CUT__
replacewith=`which cut`
SR

searchfor=__TEST__
replacewith=`which test`
SR

searchfor=__MAIL__
replacewith=`which mail`
SR

searchfor=__GREP__
replacewith=`which grep`
SR

searchfor=__FILE__
replacewith=`which file`
SR

searchfor=__FIND__
replacewith=`which file`
SR

searchfor=__TOUCH__
replacewith=`which file`
SR

searchfor=__FORMAIL__
replacewith=`which formail`
SR

searchfor=__SENDMAIL__
replacewith=`which sendmail`
SR

searchfor=__RIPMIME__
replacewith=`which ripmime`
SR


			
echo -e "\nInstall version : $install_version\n\n\n\n\
                 \033[0;37mWelcome to \033[1;37minflex${doff}\n\
					  \n\
					  \n\
This install program will perform the following operations...\n\
\n\
	. Ask a series of questions regarding inflex\n\
	. Create required user/group account\n\
	. Locate your sendmail.cf and create a inflex.cf\n\
	. Ask you 'are you really sure'...\n\
	. Install inflex files into specified location\n\
	. Inform you of changes made.\n\n"


# clear our log file
echo "" > $report

# Find our Crontab
#
if [ -e /var/spool/cron/crontabs/root ]
then
	# SLACKWARE location
	crontabfile=/var/spool/cron/crontabs/root
	fi
	
if [ -e /etc/crontab ]
then
	# REDHAT location
	crontabfile=/var/spool/cron/tab/root
	fi
	
	

# Find our sendmail.cf
#
if [ -e /etc/sendmail.cf ]
then
	sendmailcf=/etc/sendmail.cf
	fi
	
if [ -e /etc/mail/sendmail.cf ]
then
	sendmailcf=/etc/mail/sendmail.cf
	fi

searchfor=__SENDMAIL_CF__
replacewith=$sendmailcf
SR
	
	
	
inflexdir=/usr/local/inflex
echo -n -e "inflex install directory? [$don${inflexdir}$doff] : "
read x
if [ "a$x" != "a" ] 
then
	inflexdir=$x
	fi

#
# Now that we have the inflex install dir, we can convert the raw inflex file
#
searchfor=__INFLEXDIR__
replacewith=$inflexdir
SR

echo -n -e "inflex user [$don${username}$doff] : "
read x
if [ "a$x" != "a" ]
then
	username=$x
	fi
	
echo -n -e "inflex group [$don${groupname}$doff] : "
read x
if [ "a$x" != "a" ]
then
	groupname=$x
	fi
		
echo -n -e "User to receive all email blocked reports ? [$don${adminemail}$doff] : "
read x
if [ "a$x" != "a" ]
then
	adminemail=$x
	fi

searchfor=__ADMIN_EMAIL__
replacewith=$adminemail
SR

echo -n -e "Sendmail configuration file [$don${sendmailcf}$doff] : "
read x
if [ "a$x" != "a" ]
then
	sendmailcf=$x
	fi


echo -n -e "\n\n\n\n\
Details of your installation...\n\
	    Install path: $dg$inflexdir$doff\n\
	    inflex User: $dg$username$doff\n\
	   inflex Group: $dg$groupname$doff\n\
	     Admin Email: $dg$adminemail$doff\n\
	Sendmail.cf file: $dg$sendmailcf$doff\n\
	\n\
Are these details correct (y/n) : "
read x

if [ "a$x" != "ay" ]
then
	echo -e "\n\
	You can reinstall simply by typing in ./install.sh again.\n\n\n"
	exit
	fi

	
#
# get a line count of how many inflex's appear in 
# either passwd/group
#
userresult=`grep $username $passwd | wc -l`
groupresult=`grep $groupname $group | wc -l`

# Create our user/group as required
#
if [ $groupresult -eq 0 ]
then
	groupadd ${groupname}
	echo -e "added group '${groupname}'..$don done$doff."
else
	echo -e "group '$groupname'$don already exists$doff."
	fi

if [ $userresult -eq 0 ]
then
	useradd -d ${inflexdir} -g ${groupname} -s /bin/false ${username}
	echo -e "added user '${username}'..$don done$doff." 
else
	echo -e "user '$username'$don already exists$doff."
	fi

#
# Get the uid/gid
#
uid=`grep $username $passwd | cut -d: -f3`
gid=`grep $username $passwd | cut -d: -f4`

# Create our inflex.cf file off the existing sendmail.cf

# first, update our MDA mods file...
echo -n "Creating MDA file..."
echo -e "\n\
Minflex,	P=${inflexdir}/inflex, F=ClsDFM:/|@qShPm,\n\
		S=0, R=0, T=DNS/RFC822/X-Unix,\n\
		A=inflex \$h \$u \$f " > ./Minflex.MDA
echo -e "$don done.$doff"

# Then apply it to the current sendmail.cf file...
echo -n "Applying updates to current sendmail.cf to create inflex.cf..."
./fixcf -s ${inflexdir}/spool -t ${inflexdir}/inflex.st -m ./Minflex.MDA -i ${sendmailcf} -o ./inflex.cf > /dev/null 2>/dev/null
echo -e "$don done.$doff"

# Create the directories...
echo "Installing files..."
mkdir -p ${inflexdir} >>$report 2>>$report
mkdir -p ${inflexdir}/spool  >>$report 2>>$report
mkdir -p ${inflexdir}/tmp >>$report 2>>$report

# Set the permissions...
chown ${username}.${groupname} ${inflexdir}
chmod a+wx ${inflexdir}/spool >>$report 2>>$report
chmod a+wx ${inflexdir}/tmp >>$report 2>>$report
chown -R ${username}.${groupname} ${inflexdir}  >>$report 2>>$report

# Install our binaries
mv inflex.raw inflex
install -c -m 700 -o ${username} -g ${groupname} inflex ${inflexdir}  >>$report 2>>$report

# Set root.root ability of the inflex file
chmod a+s ${inflexdir}/inflex >>$report 2>>$report


# Install the Auxilary files...
fmode=600
for source in inflex.cf;
do
	askow
done

echo -e "$don done.$doff"

# Now, lets clean up any temp files...
#
echo -n "cleaning up temporary install files..."
echo -e "$don done.$doff"



# now lets do the sendmail -q
#
#
cronexists=`grep sendmail ${crontabfile} | grep -v grep | wc -l`

# now lets do the sendmail -q
#
#
if [ $cronexists -eq 0 ]
then
	echo -n -e "\n\n\n\
		Install sendmail periodic (15 minute) queuing in crontab (y/n) ? : "
	read x

	if [ "a$x" = "ay" ]
	then
		echo -n -e "Crontab file location [$don${crontabfile}$doff] : "
		read x
	
		# if the user entered something, then we better use it 
		#
		if [ "a$x" != "a" ]
		then
			crontabfile=$x
			fi
		
		echo -n -e "Installing cronjob into ${cronttabfile}..."
		echo "0,15,30,45 0 * * *	${sendmailpg} -q" >> ${crontabfile}
		echo -e "$don done$doff."
		fi
	fi

if [ ${cronexists} -ne 0 ]
then
	echo -e "Crontab entry already exists, $don skipping update$doff\n"
	fi



#
# Ask if we want to restart sendmail...
#
echo -n -e "\n\
	Do you want to restart sendmail (y/N) : "
read x
if [ "a$x" = "ay" ]
then
	killall sendmail
	sleep 2
	${sendmailpg} -bd -q15m -C ${inflexdir}/inflex.cf
	count=`ps -ax | grep sendmail | grep -v grep | wc -l`
	if [ $count -gt 0 ]
	then
		echo -e "$don Successfully restarted$doff."
	else
		echo -e "$dr Error - Could not restart$doff."
		fi
	fi
	
	
	
# Test the size of the log file, if there are more than 0 lines in it, then we have had errors
#
logsize=`cat $report | wc -l`
if [ $logsize -gt 0 ]
then
	echo -e "\n\n\nThere may have been errors in the Inflex installation,
please check $report for details.\n\n"
else
	echo -e "\n\n\nCongratulations, Inflex is installed.\n\n"
	fi
	
echo -e "Please add the new sendmail startup to your startup\n\
scripts, the startup line should now appear as...\n\
\n\
	${sendmailpg} -bd -q15m -C ${inflexdir}/inflex.cf\n\
\n\
Thankyou and enjoy the new safety of your email...\n\n\
This install script was backported from the commercial XaMime Email\n\
sanitation program. http://xamime.com\n\n\
$install_version"

#
# revert the inflex.raw back, so if we run install again,it's okay!
cp inflex.raw.safe inflex.raw
